// LoadProcWrappersRetVal.h: templaes and macros for the wrapper definitions
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOADPROCWRAPPERSRETVAL_H__1B5F3CBF_A737_4AA2_9E4D_62A85E3122B9__INCLUDED_)
#define AFX_LOADPROCWRAPPERSRETVAL_H__1B5F3CBF_A737_4AA2_9E4D_62A85E3122B9__INCLUDED_

#include "LoadProcWrapperBase.h"


//==============================================================================
// 5 templates for 0 - 4 parameters

template
<
   typename T_RET, 
   const TCHAR * const * _pszDllName = NULL, 
   const char  * const * _pszExportName = NULL
> 
class LoadProc0WrapperRetVal : public LoadProcWrapperRetVal<T_RET, _pszDllName, _pszExportName>
{
protected:
   typedef  T_RET (WINAPI * t_pf) (void);

public:
   virtual T_RET operator()()
   {
      GetTheFunction();
      if ( m_pf == NULL ) {
         return GetDefaultValue();
      }
      return ((t_pf)m_pf)();
   }
};

//------------------------------------------------------------------------------

template
<
   typename T_RET, 
   typename T_P1, 
   const TCHAR * const * _pszDllName = NULL, 
   const char  * const * _pszExportName = NULL
> 
class LoadProc1WrapperRetVal : public LoadProcWrapperRetVal<T_RET, _pszDllName, _pszExportName>
{
protected:
   typedef  T_RET (WINAPI * t_pf) (T_P1);

public:
   virtual T_RET operator() (T_P1 p1)
   {
      GetTheFunction();
      if ( m_pf == NULL ) {
         return GetDefaultValue();
      }
      return ((t_pf)m_pf)(p1);
   }
};

//------------------------------------------------------------------------------

template
<
   typename T_RET, 
   typename T_P1, 
   typename T_P2, 
   const TCHAR * const * _pszDllName = NULL, 
   const char  * const * _pszExportName = NULL
> 
class LoadProc2WrapperRetVal : public LoadProcWrapperRetVal<T_RET, _pszDllName, _pszExportName>
{
protected:
   typedef  T_RET (WINAPI * t_pf) (T_P1, T_P2);

public:
   virtual T_RET operator() (T_P1 p1, T_P2 p2)
   {
      GetTheFunction();
      if ( m_pf == NULL ) {
         return GetDefaultValue();
      }
      return ((t_pf)m_pf)(p1, p2);
   }
};

//------------------------------------------------------------------------------

template
<
   typename T_RET, 
   typename T_P1, 
   typename T_P2, 
   typename T_P3, 
   const TCHAR * const * _pszDllName = NULL, 
   const char  * const * _pszExportName = NULL
> 
class LoadProc3WrapperRetVal : public LoadProcWrapperRetVal<T_RET, _pszDllName, _pszExportName>
{
protected:
   typedef  T_RET (WINAPI * t_pf) (T_P1, T_P2, T_P3);

public:
   virtual T_RET operator() (T_P1 p1, T_P2 p2, T_P3 p3)
   {
      GetTheFunction();
      if ( m_pf == NULL ) {
         return GetDefaultValue();
      }
      return ((t_pf)m_pf)(p1, p2, p3);
   }
};

//------------------------------------------------------------------------------

template
<
   typename T_RET, 
   typename T_P1, 
   typename T_P2, 
   typename T_P3, 
   typename T_P4, 
   const TCHAR * const * _pszDllName = NULL, 
   const char  * const * _pszExportName = NULL
> 
class LoadProc4WrapperRetVal : public LoadProcWrapperRetVal<T_RET, _pszDllName, _pszExportName>
{
protected:
   typedef  T_RET (WINAPI * t_pf) (T_P1, T_P2);

public:
   virtual T_RET operator() (T_P1 p1, T_P2 p2, T_P3 p3, T_P4 p4)
   {
      GetTheFunction();
      if ( m_pf == NULL ) {
         return GetDefaultValue();
      }
      return ((t_pf)m_pf)(p1, p2, p3, p4);
   }
};

//==============================================================================

#define  LOADPROC_WITH_RETURN_VALUE_0(TYPEDEFNAME, DLLNAME, EXPORTTNAME, T_RET) \
extern const char * const TYPEDEFNAME##_L = DLLNAME; \
extern const char * const TYPEDEFNAME##_E = EXPORTTNAME; \
typedef LoadProc0WrapperRetVal<T_RET, &TYPEDEFNAME##_L, &TYPEDEFNAME##_E> TYPEDEFNAME;
//------------------------------------------------------------------------------
#define  LOADPROC_WITH_RETURN_VALUE_1(TYPEDEFNAME, DLLNAME, EXPORTTNAME, T_RET, T_P1) \
extern const char * const TYPEDEFNAME##_L = DLLNAME; \
extern const char * const TYPEDEFNAME##_E = EXPORTTNAME; \
typedef LoadProc1WrapperRetVal<T_RET, T_P1, &TYPEDEFNAME##_L, &TYPEDEFNAME##_E> TYPEDEFNAME;
//------------------------------------------------------------------------------
#define  LOADPROC_WITH_RETURN_VALUE_2(TYPEDEFNAME, DLLNAME, EXPORTTNAME, T_RET, T_P1, T_P2) \
extern const char * const TYPEDEFNAME##_L = DLLNAME; \
extern const char * const TYPEDEFNAME##_E = EXPORTTNAME; \
typedef LoadProc2WrapperRetVal<T_RET, T_P1, T_P2, &TYPEDEFNAME##_L, &TYPEDEFNAME##_E> TYPEDEFNAME;
//------------------------------------------------------------------------------
#define  LOADPROC_WITH_RETURN_VALUE_3(TYPEDEFNAME, DLLNAME, EXPORTTNAME, T_RET, T_P1, T_P2, T_P3) \
extern const char * const TYPEDEFNAME##_L = DLLNAME; \
extern const char * const TYPEDEFNAME##_E = EXPORTTNAME; \
typedef LoadProc2WrapperRetVal<T_RET, T_P1, T_P2, T_P3, &TYPEDEFNAME##_L, &TYPEDEFNAME##_E> TYPEDEFNAME;
//------------------------------------------------------------------------------
#define  LOADPROC_WITH_RETURN_VALUE_4(TYPEDEFNAME, DLLNAME, EXPORTTNAME, T_RET, T_P1, T_P2, T_P3, T_P4) \
extern const char * const TYPEDEFNAME##_L = DLLNAME; \
extern const char * const TYPEDEFNAME##_E = EXPORTTNAME; \
typedef LoadProc2WrapperRetVal<T_RET, T_P1, T_P2, T_P3, T_P4, &TYPEDEFNAME##_L, &TYPEDEFNAME##_E> TYPEDEFNAME;

//==============================================================================

#endif // !defined(AFX_LOADPROCWRAPPERSRETVAL_H__1B5F3CBF_A737_4AA2_9E4D_62A85E3122B9__INCLUDED_)
